== Changelog ==

= 5.4.9.4 =

* Prevents the use of PHP sessions, as WordPress does not rely on native PHP session handling.

= 5.4.9.3 =

* Automatically opens popups or expands collapsed fieldsets when a validation error occurs in a contained field during form submission or when navigating to the next page.
* Adds the new addItem, removeItem, and getItemsNames methods to the public JavaScript API.

= 5.4.9.2 =

* Improved the drag-and-drop behavior of controls in the form builder for greater accuracy.
* Updated the list of supported AI models.
* Enhanced nonce handling to ensure compatibility with LiteSpeed Cache.
* Updated the _setHandle function in the plugin core.
* Enhanced the Google Places add-on to support all address components (Platinum edition).

= 5.4.9.1 =

* Refactored compatibility with third-party cache and optimization plugins, while improving overall plugin performance.
* Updated the Slider control to make it easier to identify in the form builder.
* Updated the Phone control to prevent submitting the country code when no phone number digits have been entered.

= 5.4.9.0 =

* Fixes an issue introduced in the previews plugin update.

= 5.4.8.9 =

* Implements a new AI-powered feature in the Entries section that allows filtering submissions using natural language search queries.
* Modifies the Entries section to preserve the current filtering options when performing actions on submissions.
* Updates the list of supported AI models and improves the integration with the WordPress AI Connectors.

= 5.4.8.8 =

* Prevents third-party plugins from injecting notices into the Forms List and Form Builder pages.
* Enhances various visual elements.
* Fixes a minor issue with the search box in phone number controls.
* Implements an arithmetic CAPTCHA in the commercial editions of the plugin (Professional, Developer, and Platinum).

= 5.4.8.7 =

* Enhanced the AI Form Generator module and fixed a minor issue in the form JSON schema.
* Updated the list of supported AI models.
* Added new menu options.
* Improved the user interface.
* Introduced Clippy.

= 5.4.8.6 =

* Redesigned plugin interface for a smoother, more intuitive experience.
* Strengthened security and boosted performance across the board.
* Updated Cloud AI models with the latest enhancements and accuracy improvements.
* Added a lightweight local model for fast, efficient in-browser inference.

= 5.4.8.5 =

* Fixed a minor conflict with Divi 4 that could load forms inside an iframe even when the iframe option was disabled.
* Enhanced deletion confirmation dialogs by automatically setting focus on the confirmation button, improving accessibility and user experience.

= 5.4.8.4 =

* Includes entry modules to store information collected by the form in the website's database.
* Enhances boot protection.
* Improves the plugin code.

= 5.4.8.3 =

* Implements spam protection through integration with Akismet.
* Enhances the form reset process for improved reliability and usability.
* Updates the AI models to the latest available versions.
* Introduces new hooks, including both actions and filters.

= 5.4.8.2 =

* Optimizes the admin interface styles.
* Improves the banner design and functionality.
* Enhances Template 12.
* Includes various core improvements and optimizations.
* Enhances the Coupons module to once you enter a coupon code, the discount hint text is updated automatically when the calculated price varies(available in the Professional, Developer, and Platinum editions).
* Extends the CFFCHART operation to support a field name as the additional parameter used to store the generated image source of the chart, in addition to supporting the field object (available in the Developer and Platinum editions).

= 5.4.8.1 =

* Added a new AI Assistant feature that automatically generates notification email content.
* Improved the plugin's user interface for a more streamlined experience.
* Updated the Mollie SDK in the Platinum version of the plugin.

= 5.4.8.0 =

* Optimizes all CSS templates for improved performance and compatibility.
* Updates the list of supported Anthropic/Claude models.
* Resolves all PHP 8.5 deprecation warnings and compatibility issues.
* Fixes minor issues affecting the Slider control.

= 5.4.7.9 =

* Fixes a 504 timeout issue that could occur under certain server configurations.

= 5.4.7.8 =

* Improves WordPress 7.0 integration, helping prevent timeouts when working with large prompts.
* Implements a new confirmation dialog module to prevent users from taking irreversible actions without a clear and explicit confirmation.
* Updates the list of supported AI provider modules.

= 5.4.7.7 =

* Modifies the Coloris integration.

= 5.4.7.6 =

* Added support for the new Chrome Browser AI API in the AI Assistant module to enhance the local AI inference directly in the browser.
* Included minor updates to the default template to ensure compatibility with WordPress 7.0.

= 5.4.7.5 =

* Fixes an issue affecting tab navigation through the form when calculated fields are configured as editable.

= 5.4.7.4 =

* Improves the Radio Buttons and Checkbox fields, making it easier to associate images with their choices.
* Updates the AI form generation and assistant models by removing deprecated ones.

= 5.4.7.3 =

* Updates the module responsible for validating the page headers.

= 5.4.7.2 =

* Includes new video tutorials.
* The Calculated Fields Form introduces agentic capabilities, enabling AI editors and agents to access form submissions directly.

= 5.4.7.1 =

* Allows associating audio tutorials with fieldset controls.
* Fixes the spinner behavior in number and currency fields, preventing overly sensitive responses that caused values to increase or decrease twice per step on touchpad only.

= 5.4.7.0 =

* Enhances the Fields and Form Design settings to help you quickly identify incorrect CSS pairs of rules and values by displaying a clear warning icon whenever an issue is detected.
* Improves usability for color-related CSS properties (such as background-color, border-color, color, etc.) by replacing the standard input with an intuitive color picker for faster and more accurate selection.
* Adds support for the DeepSeek AI provider in both form generation and code asistant.
* Updates the Classic CAPTCHA module with a modern design and ensures that browser autocomplete is disabled for a smoother and more secure user experience (Professional, Developer, and Platinum plugin distributions).

= 5.4.6.9 =
= 5.4.6.8 =

* Adds support for GPT-5.5 and GPT-5.5 Pro models.
* Introduces integration with the WordPress Connector module, allowing the use of AI providers configured under Settings > Connector in WordPress 7.0.
* Fixes an issue affecting the CSS editor in the Customize Form Design setting and the HTML editor in HTML Content fields when using fullscreen mode. In Firefox, the scrolling of elements behind the editor could be visible for a few seconds.
* Improves usability by keeping the form preview button accessible while the HTML editor is in fullscreen mode, making it easier to review changes.
* Resolves a conflict with Content Security Policy (CSP) rules.

= 5.4.6.7 =

* Allows closing the banner in the form preview.
* Improves the 'Create New Form' popup: adds a forward button to return to the generated form after going back, and provides feedback when a large model is selected and generation takes longer than usual.
* Adds support for the Kimi-2.6 model.
* Displays the 'Add-ons' option in the form builder navigation bar when add-ons or complementary plugins are available.
* Refines the right floating menu to clearly separate action-related options (such as generate preview, save form, or create a new form) from section navigation controls.
* Optimizes the plugin installation process.
* Updates the 'Advanced Settings' section in controls, renaming it to 'Design Settings' and simplifying the instructional text.
* Standardizes control sizing by setting the default size to medium across all controls.
* Adds a preview button within the 'Customize Form Design' attribute when the CSS editor is in fullscreen, making it easier to preview changes without resizing the editor.
* Updates default templates 15, 16, and 17.

= 5.4.6.6 =

* Enhances the Number, Currency, and Calculated Fields with improved performance and greater flexibility for more accurate and dynamic calculations.
* Adds support for additional AI providers such as MiniMax and Kimi (Moonshot AI), offering powerful and cost-efficient models compared to other providers.

= 5.4.6.5 =

* Fixes an issue where the initial prefix and postfix symbols were not correctly applied to number fields, and currency symbols were not properly assigned to currency fields when automatic formatting was disabled.

= 5.4.6.4 =

* Fixes an issue displaying the Import Form Fields dialog when the form builder is in fullscreen.

= 5.4.6.3 =

* Enhances the Import Form Fields widget by enabling form grouping into categories within the import popup, improving organization and usability.
* Refines the Map Widget by removing unnecessary attributes for a cleaner and more efficient implementation.
* Updates the Anthropic models list by removing deprecated models, ensuring better accuracy and maintainability.

= 5.4.6.2 =

* Updates the Number, Currency, and Calculated fields to ensure that prefix and postfix attribute values are dynamically updated based on other field values.
* Introduces a Map Widget, enabling maps to be embedded within forms and synchronizing user-selected map pins with single-line text fields.
* Enhances the AI Form Generation module by increasing token limits and timeout settings, and removing deprecated models from the selection list.

= 5.4.6.1 =

* Modifies the URL Operations module to allow accessing the top URL parameters even if the form is sandboxed in an iframe.
* Optimizes the form generation from templates process.
* Adds CALCULATEAMORTIZATIONITALIAN to the Financial Operations module to use the Italian amortization method (available in Developer and Platinum editions).

= 5.4.6.0 =

* We have introduced an improvement that prevents adding Page Break controls inside container fields such as divs, fieldsets, and popups. Since Page Breaks operate at the form level, placing them within containers can result in incorrect or unintended page layouts.
* Updated the Import Form Fields widget to exclude Page Break controls, as imported fields are placed within a container field.
* The additional choice option is now ignored in dropdown fields configured for multiple selections, as it is unnecessary and may cause confusion.
* Extended the CSS rules in Form Settings / Advanced Settings so that button styles also apply to the Apply Coupon button (available in Professional, Developer, and Platinum editions).

= 5.4.5.9 =

* Introduces a new Widgets control category, enabling you to seamlessly reuse controls from different contexts. The first available widget allows you to import fields directly from existing forms, streamlining form creation.
* Fixes a minor alignment issue affecting images in dropdown fields when the search box option is enabled, ensuring a cleaner and more consistent UI.
* Updates the default field sizes for number, currency, and slider controls from small to medium, providing improved visual consistency across all default control sizes.
* Enhances the results list shortcode to support passing attribute values via URL parameters (available in Professional, Developer, and Platinum editions), increasing flexibility for dynamic integrations.
* Updates the Paycomet add-on to ensure full compatibility with the latest API changes (available in the Platinum version).

= 5.4.5.8 =
= 5.4.5.7 =

* Improves pagination in multi-page forms to ensure that empty pages, those without accessible fields, do not introduce unnecessary delays.
* Enhances the fields list popup to provide quicker and more intuitive shortcuts for navigating directly to fields within the form.
* Implements lazy loading for the CAPTCHA image, improving overall form loading and rendering performance (available in Professional, Developer, and Platinum versions).

= 5.4.5.6 =

* Fixes an issue in the Divi 5 integration module.

= 5.4.5.5 =

* Modifies the default thank-you page URL behavior. If the URL is empty after form submission, the user is redirected to the page containing the form.
* Improves validation handling by introducing a countdown timer and automatically redirecting users back to the form once the timer ends.
* Updates the list of supported Gemini models.
* Optimizes the 'Create New Form' dialog for a smoother user experience.
* Adds a new button in the create form section over the Forms list to provide direct access to the AI Form Generation section.
* Removes certain characters from field short labels to prevent conflicts when exporting to CSV or using them with data source controls.
* Enhances the Submissions Data Source module to support filtering by short labels and to include short labels in returned records, simplifying the generalization process (available in Developer and Platinum versions).

= 5.4.5.4 =

* Implements the 'Enable minimum time to submit (in seconds)' security feature to help detect and block bot submissions that bypass other security measures.
* Verifies that the form is not submitted empty; if all fields are blank, an additional security check intercepts the submission and displays an error message.

= 5.4.5.3 =

* Fixes a conflict with last WP version.

= 5.4.5.2 =

* Enhances the form submission process to ensure validation rules are executed even when the form is submitted programmatically.
* Implements the SUBMITFORM operation within the Managing Fields module, allowing users to trigger form submission via code when needed.
* Updates the predefined form layouts for improved structure and usability.
* Replaces the Apply Coupon icon with a standard button to provide a more user-friendly interface (available in Professional, Developer, and Platinum editions).

= 5.4.5.1 =
= 5.4.5.0 =

* Improves the plugin security by validating user capabilities. Thanks to the Wordfence team and their contributors.

= 5.4.4.9 =

* Adds conditional logic to the Next Page button, Submit button, payment options, and CAPTCHA, allowing them to depend on other field values like any form control.
* Includes support for GPT-5.4 and GPT-5.4 Pro.

= 5.4.4.8 =

* Modifies the form builder to apply distinct border colors to fields at different nesting levels. This enhancement makes it easier to identify sibling fields and recognize which fields belong to the same level in the hierarchy during the development process.

= 5.4.4.7 =

* Adds support for Gemini 3 Flash Preview and Gemini 3.1 Pro Preview models, enabling faster and more advanced AI-powered form generation.
* Introduces three new pre-designed layouts, easily selectable from the 'Form Settings' tab for improved form customization and styling.

= 5.4.4.6 =

* Enhances the AI Assistant module by improving local model inference performance and optimizing overall functionality. The AI Assistant settings section has also been updated to provide clear feedback when configuration changes have not been saved.
Since most users do not have devices with sufficient resources to run local inferences efficiently, the assistant no longer loads local models by default. Instead, it offers alternative providers and models as the default option, while still allowing users to select and run models locally if they prefer.

= 5.4.4.5 =

* Updates the Forms List to ensure full compatibility with WordPress 7.x (currently in beta).
* Adds support for Claude Sonnet 4.6, expanding AI capabilities and performance.
* Enhances the AI Form Generator module, allowing users to request additional form modifications directly from the AI model.
* Improves the Event Calendar add-on to prevent issues caused by empty date values, including missing Start or End dates (Platinum plugin distribution).

= 5.4.4.4 =

* Reimplements the AI Form Generation module. The new generator enables developers to select from multiple AI providers and models, while optimizing the JSON schema to minimize token usage and improve form generation efficiency.
* Enhances the AI Assistant within forms, providing improved functionality and performance.
* Integrates the AI Assistant in Dropdown, Checkbox, and Radio Buttons controls to generate their choices automatically.

= 5.4.4.3 =
= 5.4.4.2 =

* We removed COOKIES and the SESSION options form the variables shortcode for security reasons. Thanks to Patchstack team.

= 5.4.4.1 =
= 5.4.4.0 =

* Fixes a compatibility issue that caused conflicts with very outdated versions of jQuery.

= 5.4.3.9 =

* Reimplements parts of the form builder to improve the visibility and prominence of the form structure section, and fixes an issue in the dashboard section.

= 5.4.3.8 =

* Optimizes the Single Line Text and Email controls.
* Modernizes the File Upload control.
* Replaces the Ctrl+R shortcut with Ctrl+M, since Ctrl+R is commonly used by browsers.
* Adds support for modern Anthropic models in the AI assistant.
* Enhances the Divi 5 module.

= 5.4.3.7 =

* Adds support for displaying the week of the year in date pickers (Date/Time and Date/Time Slots controls).
* Introduces keyboard shortcuts to quickly manage fields: duplicate (Ctrl+D), remove (Ctrl+R), collapse (Ctrl+L), and expand (Ctrl+U) the selected field.
* Allows control over the WordPress nonce lifetime. To extend the nonce lifetime to 48 hours, simply define the following constant in the config.php file located in your WordPress root: define('CP_CALCULATEDFIELDSF_NONCE_LIFE', 172800); // 48 hours in seconds
* Improves the iCal add-on (available in the Platinum plugin distribution).

= 5.4.3.6 =

* Updated the setVal method for Date/Time controls to support native Date objects.
* Improved the initial landing page for a clearer and more intuitive user experience.
* Enhanced menu accessibility to ensure better usability and navigation.
* Fixed an issue affecting chart sets on DS fields (Developer and Platinum editions).

= 5.4.3.5 =

* Resolves a minor issue with the Upload File control when disabled by dependencies.
* Adds support for iCS/iCal data sources in DS fields (developer plugin distribution).
* Updates the Date DS control to support iCS/iCal properties.
* Implements new features in the iCal add-on to expose submissions in iCS/iCal format via a dedicated endpoint URL (Platinum plugin distribution).

= 5.4.3.4 =

* Enhances the email diagnostics feature module.
* Improves both the ACTIVATEFIELD and IGNOREFIELD operations in the Managing Fields operations module.
* Improves the DS fields set.

= 5.4.3.3 =

* Fixes an issue that occurred when creating new forms from templates on servers that do not allow connections to the template distribution service via cURL.
* Implements an email diagnostics feature, allowing website owners to detect issues with their server’s email configuration.
* Updates form styles to hide fieldset legends when they are empty.
* Improves the entries section by grouping form submissions by month and year (Professional, Developer, and Platinum versions).
* Fixes a minor issue in the submissions data source for DS fields (Developer and Platinum versions).

= 5.4.3.2 =

* Fixed deprecated notices to ensure compatibility with the latest PHP versions.
* Applied minor improvements to the form settings.
* Prevented a critical error when the server has the mail function explicitly disabled.

= 5.4.3.1 =

* Updates the val method across all controls to prevent issues when values, attributes, and choices are assigned to fields while they are inactive.
* Improves the control settings by loading dropdown components with search functionality (Select2) only when needed. This change was necessary because, in controls such as checkboxes, radio buttons, dropdowns, and calculated fields with many dependencies, applying Select2 to all dependent fields lists at once caused noticeable browser performance lag.
* Add indexes to database tables to enhance query performance.

= 5.4.3.0 =

* Modifies the Currency and Number controls to resolve a conflict in value assignment when they are inactive.

= 5.4.2.10 =

* Includes new video tutorials in the Video Tutorials popup window.

= 5.4.2.9 =

* Improves the appearance of submit buttons across all predefined layouts.
* Updates the plugin registration process.
* Adds links to the website registration page for anonymous users in the User Permissions add-on (Developer and Platinum editions).
* Reimplements the WebHooks add-on by moving the JWT authentication class into a standalone file, allowing it to be reused by multiple add-ons (Developer and Platinum editions).

= 5.4.2.8 =

* The AI Assistant was reimplemented to support long responses that require multiple, subsequent requests to the provider and model when generating complex code.

= 5.4.2.7 =

* Updates the Number, Currency, and Calculated fields.
* Updates the WooCommerce add-on to support redirecting users to the thank-you page when a form is submitted independently.

= 5.4.2.6 =

* Fixes a minor issue with stray spaces in currency and prefix symbols, and in currency name and postfix symbols.
* Improves vertical alignment of checkboxes and radio buttons relative to their labels.
* Reimplements the Google Places add-on to populate form fields with address components.

= 5.4.2.5 =

* Modifies the Currency, Number, and Calculated Fields controls to allow inserting variables, URL parameters, or other field tags into the currency symbol, currency name, prefix, and postfix attributes; including the symbols shown at the start and end of calculated-field values. This makes it easy to support multiple currencies or switch between metric and imperial units by driving displayed symbols and labels from form data or URL parameters.
* Include additional global JavaScript variables in the WooCommerce add-on exposing product width, length, height, and weight so they can be accessed directly from calculation logic.

= 5.4.2.4 =

* Fixes a minor issue in the Phone control.

= 5.4.2.3 =

* Ensures compatibility with the Text Editor module in the latest Elementor update.
* Reimplements the WebHook add-on in the Developer and Platinum plugin distributions to support multiple security algorithms for WebHook URLs. Additionally, it triggers a new action with the information received from the WebHook.

= 5.4.2.2 =
= 5.4.2.1 =

* Reimplemented the AI Assistant to allow the selection of advanced AI providers, such as OpenAI, Gemini, and Anthropic, in addition to browser inference.
* Modified the AI Form Generator module to utilize a more advanced AI model.
* Adjusted the SHOWFIELD, HIDEFIELD, and ISHIDDEN operations to enable showing and hiding tags on the form using their selectors rather than just field names.
* Fixed a minor issue with phone fields configured as required that had predefined values.
* Resolved a minor CSS conflict in the form filter section of the forms list.
* Introduced a new attribute in the WooCommerce add-on settings to visually control the text of the 'View Product' button.

= 5.4.2.0 =

* Updates the fields validation module to validate entries only after users complete the input process, making error messages less intrusive.
* Eliminates duplicate error messages in the popup for controls with multiple components, such as phone controls.
* Adjusts the ACTIVATEFIELD and SHOWFIELD operations to enable the display of fields with a fade-in animation.
* Enhances security for DS fields (used in the Developer and Platinum distributions) by concealing error messages from the browser when an incorrect query is entered by the developer, or when an error occurs after variable replacement.

= 5.4.1.10 =

* Enhances the form builder experience on mobile devices.
* Promotes the End-of-Year Sales Offer.

= 5.4.1.9 =

* Applies autocomplete form settings to additional field components, such as date components in timeslot controls and sliders with manual value entry boxes.
* Enables control over the minimum and maximum values in the quantity boxes associated with checkbox fields.
* Assigns min-width to the quantity boxes to ensure a consistent form design.

= 5.4.1.8 =

* Allows updating the form structure by pasting information directly into the field attributes, in addition to typing information through the form builder interface.

= 5.4.1.7 =

* Enhances the functionality of the Elementor module.
* Completely reimplements the Divi Module, now featuring support for Divi 5.

= 5.4.1.6 =

* Introduced three new operations in the Managing Fields Operations module: READONLYFIELD (makes a field read-only), EDITABLEFIELD (makes a read-only field editable), and ISREADONLY (checks if a field is read-only).
* Modified the SHOWFIELD and READFIELD operations to enable the showing/hiding of various form components, not just fields. For example, you can now use HIDEFIELD('.pbSubmit') to hide the form submit button.
* Implemented the getRecords method in the RecordSet DS field, allowing access to records and their filtering. Usage example: getField(fieldname1|n).getRecords({'column': 'value'});

= 5.4.1.5 =

* Resolves a minor issue with the number and currency controls on iOS mobile devices when the option to 'Force numberpad on mobiles' is enabled, facilitating the entry of decimal numbers.
* Improves the timeslot control by enabling keyboard-only navigation between slots, allowing users to select or deselect slots seamlessly.
* Enhances the Datatable DS field functionality, permitting developers to leave the columns section empty, which will automatically include all record properties as columns in both Developer and Platinum plugin distributions.
* Updates the Stripe payment gateway module specifically for the Platinum plugin distribution, ensuring smoother payment processing.

= 5.4.1.4 =

* Modifies the Date/Time and Date/Timeslot controls to display the next valid date when the default date coincides with an invalid one.
* Internal methods are implemented in the Date/Timeslot control to allow intervals and dates to be assigned by code.
* Modifies the VALIDFORM operation in the Managing Fields Operations module to display a pop-up with a list of validation errors.

= 5.4.1.3 =

* Modifies the 'Create New' and 'Filtering' form sections to make them more accessible to users.
* Modifies the timeslot control to enable the configuration of time intervals between slots.

= 5.4.1.2 =

* Implements the PARSESLOTS operation in the Date/Time Operations module to parse the timeslot control values.
* Modifies the default label in radio buttons and dropdown controls.
* Adds a new add-on to support the Paycomet payment gateway (Platinum plugin distribution).

= 5.4.1.1 =

* Resolves an issue with placeholder attributes in Chromium-based browsers following the latest Chromium update.
* Improves access to plugin documentation.

= 5.4.1.0 =

* The 'Instructions for users' section of the text and textarea controls includes the option to integrate the AI Assistant to help users enhance their text as they populate the form. The advantage of our plugin implementation is that it infers the models directly in the browser rather than calling external services.

= 5.4.0.9 =

* Extends the offer to Black Friday.

= 5.4.0.8 =

* Enhances forms templates 09, 12 and 14.
* Improves handling of controls in the public form.
* Modifies the integration with payment gateways to allow users to return directly to the page containing the form when payments fail.

= 5.4.0.7 =

* Fixes a typo in the date/time and date/timeslots controls.
* Prevents a malfunction caused by the Cachebuster plugin.

= 5.4.0.6 =

* Modifies the equation evaluation module.
* Includes new options in the media control to align the media controls and figure captions.

= 5.4.0.5 =

* Halloween promotion.

= 5.4.0.4 =

* Includes Google Calendar integration support.
* Modifies controls such as checkboxes, radio buttons, dropdowns and containers.
* Improves the form creation module on mobile devices.

= 5.4.0.3 =

* Resolves an issue with the properties tabs when the HTML content attribute and CSS editor are in full-screen mode.
* Improves the appearance of the form builder on mobile devices.

= 5.4.0.2 =
= 5.4.0.1 =

* This update resolves some compatibility issues that were introduced in the previous plugin update.
* Revamps the JSON schema utilized by the AI form generator to improve the descriptions of controls and incorporate the Date/Timeslots one.
* Updates the settings for Checkbox, Radio Button, Dropdown, and Calculated Fields to include comprehensive details regarding dependency configurations.
* Refines container fields, such as Div, Fieldset, and Popup, to provide enhanced information about the fields distribution into columns.
* Adjusts iframe attributes for forms loaded within iframes, aiming to enhance the overall accessibility score.
* Initiates new JavaScript events to extend functionality and interactivity.

= 5.3.99 =

* Allows you to use url.param_name and var.variable_name as predefined field values to fill in fields with URL parameters and global JavaScript variables, respectively.

= 5.3.98 =

* Improves Date/Time and Date/Time slot controls.
* Adds a new feature to the WooCommerce add-on that adds form-collected information to WooCommerce webhooks data (developer and platinum plugin distributions).

= 5.3.97 =

* Adds a new set of form templates.
* Improves AI form generation.
* Fixes a minor issue with displaying field labels in the request cost attribute.
* Supports the Revolut payment gateway (Platinum plugin distribution).

= 5.3.96 =

* Modifies the form builder to improve access to the basic and advanced settings of the fields.
* It modifies the advanced settings in the container fields (div, fieldset, and popup) to provide more control over field designs.
* It includes additional attributes in the script tags to ensure that the 'Complianz | GDPR/CCPA Cookie Consent' plugin does not block them.

= 5.3.95 =

* Improves the AI form generation module.

= 5.3.94 =

* It displays confirmation dialogs during the field deletion process to prevent deleting fields by mistake. This is useful when the field is used by other fields, such as in calculated field equations or data source fields for filtering. It is also useful when deleting a container field (fieldset, div, or popup) that contains other fields.

= 5.3.93 =

* Implements a new modification to the minimum and maximum supported hours in the date/time control that allows you to enter a minimum hour greater than the maximum hour in order to deactivate intermediate hour intervals. For example, entering 20 as the minimum hour and 7 as the maximum hour will allow you to select hour intervals between 20 and 23 hours and between 0 and 7 hours but not between 7 and 20 hours.

= 5.3.92 =

* Modifies the date and time controls to ensure the minimum and maximum hours are correct.
* Allows visual customization of the error and thanks message pop-ups through the Form Design/Advanced Design tab.
* Modifies the Users Permissions add-on to ensure coherence between different levels of accessibility control (Developer and Platinum plugin distributions).

= 5.3.91 =
= 5.3.90 =

* Adds a new attribute to the phone controls to configure the symbol that separates phone components.
* Resolves an issue with switch radio buttons and checkboxes in form template 08 (dark template).
* Resolves a warning in the iCal add-on (Platinum plugin distribution).

= 5.3.89 =

* Fixes an issue with the forms builder in full mode that prevented access to the dependent fields list.
* Enables modification of previously added products in WooCommerce (Developer and Platinum plugin distributions).

= 5.3.88 =

* Implements a health-related operations module.
* Improves field filtering in the fields list pop-up in the form builder.
* Improves the module that displays field validation errors when a form is submitted.

= 5.3.87 =

* Modifies the setChoices method in checkbox, radio button, and dropdown controls for better functionality.
* Fixes a browser message that appears when honeypot protection is enabled, applicable to Professional, Developer, and Platinum plugin versions.
* Updates the metadata in Stripe Checkout payment integration to include necessary information with payment intents and subscriptions for Professional, Developer, and Platinum plugin versions.
* Addresses a minor issue in the email and phone verification add-ons, relevant to Developer and Platinum plugin versions.
* Adjusts the user information data source in the DS fields to accurately obtain the user's main role, specifically for Developer and Platinum plugin versions.
* Synchronizes the maximum and minimum attributes in product quantity boxes and form fields for quantities in forms embedded within WooCommerce products, applicable to Developer and Platinum plugin versions.
* Enables selection between website languages and users' local languages for address autocompletion in Google Places, available in the Platinum plugin version.

= 5.3.86 =

* Improves form behavior and appearance on pages with right-to-left (RTL) direction.
* Ensures DS field compatibility with the latest versions of ACF and SCF (Developer and Platinum plugin distributions).
* Modifies the Verification Code add-on for the Developer and Platinum distributions.

= 5.3.85 =

* Resolves an issue with displaying date pickers on pop-up controls.
* Addresses an issue with assigning default values to checkbox controls with quantity enabled.
* Includes the 'Send Emails' button associated with the entries in the 'Entries' section (Professional, Developer, and Platinum distributions).
* Hides the Stripe checkout option in the add-ons section because it is enabled by default (Developer and Platinum plugin distributions).
* In Data Table DS controls, it allows the use of literals to populate columns (Developer and Platinum plugin distributions).

= 5.3.84 =

* Implements a new energy-related operations module.
* Improves data entry on number and currency fields on mobile devices.
* Modifies the CALCULATEAMORTIZATION operation to allow direct generation of the HTML amortization table (Developer and Platinum plugin distributions).

= 5.3.83 =

* Adds a new subsection under Form Settings > Advanced Settings for customizing tooltip icon designs.
* Updates the CSV-import module within DS fields for both Developer and Platinum plugin editions to support CSV files containing multiline cells.
* Implements an alternative workflow in the PDF Generator add-on (Platinum plugin) that generates PDF files by populating fields within a PDF template.

= 5.3.82 =

* Displays form titles when form names are unavailable in the WordPress editor, Elementor Page Builder, or submissions list, making forms easier to identify.
* Harmonizes the 'required' setting for payment gateway options on multipage forms when those options are optional.

= 5.3.81 =

* Assigns the class name cff-form-### (where ### is replaced by the form ID), which allows for easier modification of the form's design.
* Allows you to visually personalize the design of the instructions tooltips through the Form Settings > Advanced Settings tab.
* Increases the DPI value of PDF files created by the PDF Generator add-on. Platinum distribution.

= 5.3.80 =

* Updated dependency handling in multi-page forms
* Refined button control settings
* Streamlined the plugin update process
* Enhanced Authorize.Net integration for the Platinum distribution

= 5.3.79 =

* Modifies the radio button and dropdown fields and their DS variants to activate auto-advance to the next page in multi-page forms.
* Enhances the appearance of the form builder.
* Modifies pagination in the submissions list generated by the CFF - Users Permissions add-on in the Developer and Platinum plugin distributions.

= 5.3.78 =

* Unlike many plugins that invariably save passwords as plain text, Calculated Fields Form empowers developers to choose, right from the field settings, whether to: Skip database storage entirely, Store only a secure hash, Keep a sanitized plain-text copy.

= 5.3.77 =

* The password validator has been enhanced to support customizable rules, requiring users to include lowercase letters, uppercase letters, digits, and symbols, ensuring stronger, more secure passwords.
* Added support for the if_value_is_not attribute in <%INFO%> tags, allowing you to conditionally remove fields whose value equals zero: <%INFO if_value_is_not={{0}}%>.

= 5.3.76 =

* Adds a new section under Form Settings / Advanced Settings that lets you customize the form's header appearance.
* Updates the results list shortcode so it only shows submissions tied to existing forms. When a form is deleted, its submissions are automatically removed from the shortcode output.

= 5.3.75 =

* Implemented the getQuantity method in both the Checkbox and Checkbox DS controls. This method returns an array of quantities for all checked checkboxes when quantity boxes are enabled.
* Added support for the |q modifier in equations, so you can now reference the array of quantity-box values. For example, SUM(fieldname1|q) sums the values of quantities boxes corresponding to the checked choices in the checkbox field fieldname1.
* Introduced a new info property on RecordSet DS records. When previous submissions is selected as the data source, this property provides a summary of each form submission.
* Updated the iCalc add-on to support all informative and field tags used in notification-email in the events summaries and descriptions, and not just the raw field values.
* Enhances the DataTable DS control to support footer rows displaying column summaries.

= 5.3.74 =

* Fixes a minor bug in the mechanism that delays evaluation of calculated field equations.

= 5.3.73 =

* The plugin update adds support for third-party shortcodes in the HTML Content control's content attribute.

= 5.3.72 =

* Added a new form-setting attribute that lets you fully disable form submissions.

= 5.3.71 =

* Fixed a compatibility issue with the phone control and outdated copies of the plugin.

= 5.3.70 =

* Support customizing the appearance of notifications with CSS in the free plugin distribution.

= 5.3.69 =

* It implements the SUMIF operation due to its popularity among Excel users.
* Eliminates the frame for promoting complementary plugins to simplify the interface.

= 5.3.68 =
= 5.3.67 =

* The plugin update modifies the Phone control. It includes the country name and flag alongside the prefix. Additionally, it adds a search box for quick code selection.

= 5.3.66 =

* Enhanced accessibility in the Default Form Settings section.

= 5.3.65 =

* Adds a new section under 'Form Settings / Advanced Settings', giving you full control over how asterisk symbols appear on required fields.

= 5.3.64 =

* Enhances the form builder's interface.

= 5.3.63 =

* Fixed a minor issue in the timeslots control.

= 5.3.62 =

* Explicitly include a .htaccess file in the wp-content/uploads/calculated-fields-form directory to prevent directory indexing on misconfigured servers. Special thanks to Dmitrii from CleanTalk inc.

= 5.3.61 =

* Introduced new Timeslot and Timeslot DS controls.
* Updated the RecordSet DS field to automatically reload records after submission.
* Refined the built-in Form design templates.

= 5.3.60 =

* Enhances the module responsible for replacing fields and informative tags in notification emails and thank-you pages, resolving an issue with nested block/endblock tags.

= 5.3.59 =

* Updated the URL for requesting the trial plugin installation so that it is now protected with a nonce. A big thank you to truonghuuphuc and the Patchstack team for identifying this issue.

= 5.3.58 =

* Fixed an error in the file validation module.

= 5.3.57 =

* We made a minor enhancement to the equation processing logic to ensure compatibility with legacy browsers.

= 5.3.56 =

* Enhances the Troubleshoot Area and General Settings to improve both accessibility and overall user experience.
* Updates the WooCommerce add-on to simplify displaying tax-inclusive prices. Now, with the Developer and Platinum plugin versions, you only need to tick a single checkbox in the product settings.
* Refines the Mollie integration to support all payment methods enabled in Mollie—not just iDeal—offering broader payment options in the Platinum plugin version.

= 5.3.55 =

* Enhanced the file upload protection module by introducing additional validation rules beyond those provided by WordPress. The updated module now verifies the MIME types and file contents, while file size is validated on both the client-side and server-side. Files that fail to meet these criteria are automatically rejected.
* Updated the DISTANCE and TRAVELTIME operations within the Distance Operations module to support Google's new Routes API in addition to the DistanceMatrix API (available in the Developer and Platinum plugin versions).
* Improved the reCaptcha add-on by implementing a bypass mechanism to mitigate errors when Google reCaptcha experiences high traffic (available in the Developer and Platinum plugin versions).

= 5.3.54 =

* Enhanced the form generation module to support generating complete forms using an AI agent.
* Updated the upload file field tags: they now include a text attribute that configures whether to display uploaded file URLs as anchor texts or to show only their names.

= 5.3.53 =

* Modified the AI Equation Assistant module by integrating a new model, altering the prompt and settings, and postprocessing the answer to generate more useful code.
* Added a new feature to the password controls that allows users to unmask the password text as they type.
* Implemented several improvements to the "Create New Forms" screen to streamline the user experience.
* Removed deprecated jQuery code to enhance the codebase's performance and maintain compatibility.
* Fixed a minor issue affecting the display of user emails in the entries section for commercial plugin distributions..

= 5.3.52 =

* Optimized the page break control by removing unnecessary code.
* Improved the character counter functionality in textarea controls.
* Modified template 07 to increase the contrast ratio, resulting in an improved Google score.
* Updated the interface of DS controls (for Developer and Platinum plugin distributions).
* Fixed an issue in the Event Calendar add-on (Platinum plugin distribution).

= 5.3.51 =

* Fixed an issue with the form submission URL that was causing conflicts with certain services and third-party plugins.

= 5.3.50 =

* We have introduced three new predefined forms: two for lifestyle, namely the Carbon Footprint Calculator and the Solar Power Investment Calculator, and one for the transportation category, the Car Purchase vs Lease Calculator.

= 5.3.49 =

* Modifies the AJAX-based form submission process to prevent users from inadvertently submitting the form multiple times.
* Updates the CSS and HTML code editor to address a scrolling issue when the editor is in fullscreen mode.

= 5.3.48 =

* We have implemented two new predefined forms in the Financial category: one for generating the Form 1040 U.S. Individual Income Tax Return, and another for generating Schedule C - Business Income and Expenses.

= 5.3.47 =

* Modified the spinner components in number and currency fields so they become continuous, eliminating the need to click repeatedly to adjust control values.
* Ensured that placeholders remain synchronized with third-party fields when used as default values.
* Improved the WooCommerce add-on to resolve a conflict with third-party themes that alter the behavior of add-to-cart buttons on WooCommerce products (applies to Developer and Platinum plugin versions).
* Implemented a new feature in the WebHooks add-on that allows the use of short labels instead of field names in the WebHook URL. This enhancement simplifies reusing the same WebHook URL for multiple forms (applies to Developer and Platinum plugin versions).

= 5.3.46 =

* Modifies the plugin interface by removing unnecessary sections. In the commercial plugin distributions, it unifies all payment methods—including those implemented via add-ons and complementary plugins—under the Payment Settings section.
* Implements adjustments in form generation that ensure compatibility with browser Speculation.
* Expands Stripe Checkout integration support to the Professional and Developer plugin distributions, in addition to the Platinum edition.

= 5.3.45 =

* Revamped the AI Assistant module to utilize the WebMLL library, enabling completely free, in-browser inferencing.

= 5.3.44 =

* Modifies the WordPress editor block.

= 5.3.43 =

* Modifies the calculated fields: Now, when you check the currency option in the field settings, the plugin automatically enforces two decimal places for decimal results.
* Adds a new, predefined form designed to evaluate password strength.

= 5.3.42 =

* Modifies the DIV control to give more control over the styles that affect the contained fields.
* Fixes a minor issue in the fields list popup to enhance the user experience.
* Adds a new predefined form and category of predefined forms for AI. This new form implements a texts translator using an AI model for translating texts directly in the browser.

= 5.3.41 =
= 5.3.40 =

* Enhances Phone controls to display phone numbers with hyphen separators in summary views and HTML content fields.
* Updates Number and Currency controls to support the assignment of unformatted numeric values.
* Improves collapsible fieldset controls by enabling users to open and close fieldsets using keyboard-only interactions.
* Adds a callback attribute to all DS fields, facilitating preprocessing of record values before they are assigned (affects both Developer and Platinum plugin distributions).
* Upgrades the Google Places add-on to support the latest Google Place APIs while still maintaining compatibility with the legacy API (available in the Platinum plugin distribution).

= 5.3.39 =
= 5.3.38 =

* Upgrades the Purify library version.

= 5.3.37 =

* Added a new feature in the Advanced Settings tab of the fields settings to allow to hide them by default.
* Updated the registration form add-on to support registering users with different roles using the same form. Additionally, users can now select their role directly from the form (available in both the Developer and Platinum plugin versions).
* Redesigned the interface of the PDF Generator add-on to simplify file generation for languages requiring special characters. This enhancement is part of the Platinum plugin version.

= 5.3.36 =

* Introduces new video tutorials and updates the landing page.
* Enables the display of all entry details simultaneously in the entries section. Professional, Developer, and Platinum plugin versions.

= 5.3.35 =

* Ensures full compatibility with WordPress 6.8.

= 5.3.34 =

* Eliminates dependencies on third-party libraries.
* Updates the server-side validation module to display the titles of fields that fail validation and logs errors in the error log file.
* Enhances the default forms.
* Upgrades the Select2 library.
* Optimizes database queries.
* Modifies the form preview module.
* Enhances the visualization of entries in the dashboard widget and entries list for the Professional, Developer, and Platinum plugin versions.

= 5.3.33 =

* Includes new predefined forms.

= 5.3.32 =

* Enhances the fields list window by displaying additional field details, such as control types.
* Introduces a floating menu on the main plugin page for quicker access to settings, thereby enhancing the user experience.
* Improves the -create new form- module for smoother operation.
* Adjusts form submission handling to prevent duplicate entries when using a custom submit button.
* Upgrades the form builder to deliver a better experience for developers on small screens, including mobile devices.
* Ensures full compatibility with reCAPTCHA Enterprise in both Developer and Platinum plugin distributions.

= 5.3.31 =

* Enhances forms performance.
* Updates the form preview module.
* Refines the Users Permissions add-on—streamlining role and user selection/deselection for an improved user experience (available in Developer and Platinum plugin versions).